; menu.s

	GET	macros.s

window_handle	*	8
canvas_window	*	148

menu_handler	*	0
submenu_handler	*	4
items		*	8
items_defined	*	12
title_indirect	*	16
dummy		*	20
menu_title	*	24
menu_foreground	*	36
menu_background	*	37
menu_wfore	*	38
menu_wback	*	39
width		*	40
height		*	44
gap		*	48
item_data	*	52

item_flags	*	0
item_submenu	*	4
item_iconflags	*	8
item_icontext	*	12
item_iconvalid	*	16
item_iconlength	*	20
item_size	*	24

	AREA	|____menu_init|, CODE, READONLY
	EXPORT	menu_init
menu_init

	IMPORT	main_addhandler

	STMFD	r13!,{lr}
	ADR	r1,menu_warning
	MOV	r0,#handler_menuwarning
	BL	main_addhandler
	LDMFD	r13!,{lr}
	ADR	r1,menu_menu
	MOV	r0,#handler_menu
	B	main_addhandler

menu_check
	=	"?MNU"

menu_menu
	STMFD	r13!,{r1,r4-r7,lr}
	LDR	r6,=menu_list
	LDR	r0,=menu_created
	LDR	r0,[r0]
	TEQ	r0,#0
	LDMEQFD	r13!,{r1,r4-r7,lr}
	MOV	r3,#0
	LDR	r4,menu_check
	MOV	lr,#-1
	MOV	r7,r1
menu_walk
	LDR	r2,[r1],#4
	STR	r2,[r6],#4
	CMP	r2,#-1
	BEQ	menu_found
	LDR	r5,[r0,#-4]				; Read dummy value
	TEQ	r5,r4
	BNE	menu_found
	ADD	r5,r0,#menu_handler-menu_title
	STR	r5,[r6],#4
	LDR	r5,[r5]					; Read handler routine
	TEQ	r5,#0
	MOVNE	r3,r5					; Only have last handler
	MOVNE	r7,r1
	ADD	r5,r0,r2,LSL#3
	ADD	r5,r5,r2,LSL#4				; x24
	MOVNE	lr,r2
;	LDR	r12,[r5,#item_flags]
;	TST	r12,#8
;	BNE	menu_found				; Don't continue with menu_warning entries
	LDR	r5,[r5,#item_submenu+28]		; Is it a submenu?
	CMP	r5,#&1C00000
	BGT	menu_found				; It's a pane
	CMP	r5,#&8000
	BLT	menu_found				; It's a pane (RO2)
;	SUB	r0,r5,#menu_handler-menu_title
	MOV	r0,r5
	B	menu_walk
menu_found
	MOV	r5,r3
	MOV	r3,r7					; Point to end of data
	MOV	r1,#-1
	STR	r1,[r6],#4				; Clear this bit
	STR	r1,[r6],#4				; And this bit
	MOV	r1,lr					; Last menu item...
	ADD	r0,r0,#menu_handler-menu_title		; Point to menu
	CMP	r5,#0
	LDR	r2,=menu_list
	MOV	lr,pc
	MOVNE	pc,r5					; Call handler
	LDR	r1,=menu_mouse
	SWI	XWimp_GetPointerInfo
	LDR	r2,[r1,#8]				; Get button state
	TEQ	r2,#1					; ADJUST
 [ arm32
	LDMNEFD	r13!,{r1,r4-r7,pc}
 |
	LDMNEFD	r13!,{r1,r4-r7,pc}^
 ]
	LDR	r1,=menu_created
	LDR	r1,[r1]
	LDR	r2,=menu_xy
	LDMIA	r2,{r2,r3}
	SWI	XWimp_CreateMenu			; Recreate the menu
	LDR	r1,=submenu_created
	LDMIA	r1,{r1,r2,r3}
	TEQ	r1,#0
	SWINE	XWimp_CreateSubMenu
 [ arm32
	LDMFD	r13!,{r1,r4-r7,pc}
 |
	LDMFD	r13!,{r1,r4-r7,pc}^
 ]

menu_warning
	ADD	r1,r1,#32
	STMFD	r13!,{r1,r4,r5,r6,lr}
	LDR	r6,=menu_list
	LDR	r0,=menu_created
	LDR	r0,[r0]
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r1,r4,r5,r6,pc}
 |
	LDMEQFD	r13!,{r1,r4,r5,r6,pc}^
 ]
	MOV	r3,#0
	LDR	r4,menu_check
	MOV	lr,#-1
menuw_walk
	LDR	r2,[r1],#4
	STR	r2,[r6],#4
	CMP	r2,#-1
	BEQ	menuw_found
	LDR	r5,[r0,#-4]				; Read dummy value
	TEQ	r5,r4
	BNE	menuw_found
	ADD	r3,r0,#menu_handler-menu_title
	STR	r3,[r6],#4
	LDR	r3,[r3,#4]				; Read submenu-handler routine
	ADD	r5,r0,r2,LSL#3
	ADD	r5,r5,r2,LSL#4				; x24
	MOV	lr,r2
	LDR	r5,[r5,#item_submenu+28]		; Is it a submenu?
	CMP	r5,#&1C00000
	BGT	menuw_found				; It's a pane
	CMP	r5,#&8000
	BLT	menuw_found				; It's a pane (RO2)
	MOV	r0,r5
	B	menuw_walk
menuw_found
	MOV	r1,#-1
	STR	r1,[r6],#4				; Clear this bit
	STR	r1,[r6],#4				; And this bit
	MOV	r1,lr					; Last menu item...
	ADD	r0,r0,#menu_handler-menu_title		; Point to menu
	CMP	r3,#0
	LDR	r2,=menu_list
	MOV	lr,pc
	MOVNE	pc,r3					; Call handler
 [ arm32
	LDMFD	r13!,{r1,r4,r5,r6,pc}			; And return
 |
	LDMFD	r13!,{r1,r4,r5,r6,pc}^			; And return
 ]

	AREA	|____menu_create|, CODE, READONLY
	EXPORT	menu_create
menu_create

	IMPORT	rmalloc

; r0 is ^ text
; r1 is max #items
; r2 is handler
; r3 is second handler

	STMFD	r13!,{r4-r7,lr}
	MOV	r4,r0
	MOV	r5,r1
	MOVS	r6,r2
	ADREQ	r6,menu_nullroutine
	MOVS	r7,r3
	ADREQ	r7,menu_nullroutine
	MOV	r2,#item_size
	MUL	r0,r5,r2
	ADD	r0,r0,#item_data
	BL	rmalloc
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r4-r7,pc}
 |
	LDMEQFD	r13!,{r4-r7,pc}^
 ]
	ADR	r2,init_menudata
	MOV	r1,#item_data-4
mcrt_copydata
	LDR	r3,[r2,r1]
	STR	r3,[r0,r1]
	SUBS	r1,r1,#4
	BPL	mcrt_copydata
	STR	r6,[r0,#menu_handler]
	STR	r5,[r0,#items]
	ADD	r5,r0,#menu_title
	MOV	r6,#11
mcrt_copyname
	LDRB	r1,[r4,r6]
	STRB	r1,[r5,r6]
	SUBS	r6,r6,#1
	BPL	mcrt_copyname
	STR	r7,[r0,#submenu_handler]
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

menu_nullroutine
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

init_menudata
	DCD	0,0,0,0,0
	=	"?MNU"
	DCD	0,0,0
	=	7,2,7,0
	DCD	0,44,0

	AREA	|____menu_add|, CODE, READONLY
	EXPORT	menu_add
menu_add

	STMFD	r13!,{r4-r6,lr}
	ADD	r2,r0,#item_data
	LDR	r3,[r0,#items_defined]
	ADD	r2,r2,r3,LSL#4
	ADD	r2,r2,r3,LSL#3
	CMP	r3,#0
	LDRNE	lr,[r2,#-item_size+item_flags]
	BICNE	lr,lr,#128
	STRNE	lr,[r2,#-item_size+item_flags]
	ADD	r3,r3,#1
	STR	r3,[r0,#items_defined]
	MOV	r6,#0
	ADD	r4,r2,#item_icontext
	LDR	r3,madd_flags
madd_findlen
	LDRB	r5,[r1,r6]
	CMP	r6,#12
	STRLTB	r5,[r4,r6]
	CMP	r5,#32
	BLT	madd_short1
	ADD	r6,r6,#1
	B	madd_findlen
madd_short1
	MOV	lr,r6,LSL#4			; x16
	ADD	lr,lr,#32			; Add some just for safety...
	LDR	r5,[r0,#width]
	CMP	r5,lr
	STRLT	lr,[r0,#width]
	CMP	r6,#12
	BLT	madd_short
	STR	r1,[r4]
	MOV	r1,#-1
	STR	r1,[r4,#4]
	MOV	r1,#48
	STR	r1,[r4,#8]
	ORR	r3,r3,#256
madd_short
	STR	r3,[r2,#item_iconflags]
	MOV	r5,#128
	STR	r5,[r2,#item_flags]
	MOV	r1,#-1
	STR	r1,[r2,#item_submenu]
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

madd_flags
	DCD	&07000001

	AREA	|_menu_temp|, COMMON, NOINIT

menu_xy
	%	8
menu_created
	%	4
menu_mouse
	%	20
menu_list
	%	256
submenu_created
	%	12

	AREA	|____menu_display|, CODE, READONLY
	EXPORT	menu_display
menu_display

	MOV	r3,#0
	LDR	r2,=submenu_created
	STR	r3,[r2]
	MOV	r2,r0
	LDR	r1,=menu_mouse
	SWI	XWimp_GetPointerInfo
	LDR	r3,=menu_created
	MOV	r0,r1
	ADD	r1,r2,#menu_title
	STR	r1,[r3]
	LDMIA	r0,{r2,r3}
	SUB	r2,r2,#64
	LDR	r0,=menu_xy
	STMIA	r0,{r2,r3}
	SWI	XWimp_CreateMenu
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_displaylocation|, CODE, READONLY
	EXPORT	menu_displaylocation
menu_displaylocation

; r0 is menu
; r1 is x
; r2 is y

	LDR	r3,=menu_mouse
	STMIA	r3,{r1,r2}
	MOV	r2,r0
	MOV	r0,r3
	LDR	r3,=menu_created
;	MOV	r0,r1
	ADD	r1,r2,#menu_title
	STR	r1,[r3]
	LDMIA	r0,{r2,r3}
	SUB	r2,r2,#64
	LDR	r0,=menu_xy
	STMIA	r0,{r2,r3}
	SWI	XWimp_CreateMenu
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_submenu|, CODE, READONLY
	EXPORT	menu_submenu
menu_submenu

;	ADD	r0,r0,#item_data
	ADD	r0,r0,r1,LSL#3
	ADD	r0,r0,r1,LSL#4
	ADD	r2,r2,#menu_title
	STR	r2,[r0,#item_data+item_submenu]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_fade|, CODE, READONLY
	EXPORT	menu_fade
menu_fade

;	ADD	r0,r0,#item_data+item_iconflags
	ADD	r0,r0,r1,LSL#3
	ADD	r0,r0,r1,LSL#4
	LDR	r1,[r0,#item_data+item_iconflags]
	TEQ	r2,#0
	BICEQ	r1,r1,#1<<22
	ORRNE	r1,r1,#1<<22
	STR	r1,[r0,#item_data+item_iconflags]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_tick|, CODE, READONLY
	EXPORT	menu_tick
menu_tick

;	ADD	r0,r0,#item_data+item_flags
	ADD	r0,r0,r1,LSL#3
	ADD	r0,r0,r1,LSL#4
	LDR	r1,[r0,#item_data+item_flags]
	TEQ	r2,#0
	BICEQ	r1,r1,#1
	ORRNE	r1,r1,#1
	STR	r1,[r0,#item_data+item_flags]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_attachpane|, CODE, READONLY
	EXPORT	menu_attachpane
menu_attachpane

	LDR	r2,[r2,#window_handle]
;	ADD	r0,r0,#item_data
	ADD	r0,r0,r1,LSL#3
	ADD	r0,r0,r1,LSL#4
	STR	r2,[r0,#item_data+item_submenu]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_setfore|, CODE, READONLY
	EXPORT	menu_setfore
menu_setfore

	ADD	r0,r0,r1,LSL#3
	ADD	r0,r0,r1,LSL#4
	LDR	r1,[r0,#item_data+item_iconflags]
	BIC	r1,r1,#&f<<24
	ORR	r1,r1,r2,LSL#24
	STR	r1,[r0,#item_data+item_iconflags]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_setback|, CODE, READONLY
	EXPORT	menu_setback
menu_setback

	ADD	r0,r0,r1,LSL#3
	ADD	r0,r0,r1,LSL#4
	LDR	r1,[r0,#item_data+item_iconflags]
	BIC	r1,r1,#&f<<28
	ORR	r1,r1,r2,LSL#28
	STR	r1,[r0,#item_data+item_iconflags]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_addwriteable|, CODE, READONLY
	EXPORT	menu_addwriteable
menu_addwriteable

	STMFD	r13!,{r4-r6,lr}
	MOV	r5,r2
	MOV	r6,r3
	ADD	r2,r0,#item_data
	LDR	r3,[r0,#items_defined]
	ADD	r2,r2,r3,LSL#4
	ADD	r2,r2,r3,LSL#3
	CMP	r3,#0
	LDRNE	lr,[r2,#-item_size+item_flags]
	BICNE	lr,lr,#128
	STRNE	lr,[r2,#-item_size+item_flags]
	ADD	r3,r3,#1
	STR	r3,[r0,#items_defined]
	STR	r1,[r2,#item_icontext]
	STR	r5,[r2,#item_iconvalid]
	STR	r6,[r2,#item_iconlength]
	LDR	lr,[r0,#width]
	CMP	lr,#192
	MOVLT	lr,#192
	STRLT	lr,[r0,#width]
;	STR	r1,[r4,#8]
	LDR	r3,maddw_flags
	STR	r3,[r2,#item_iconflags]
	MOV	r5,#128+4
	STR	r5,[r2,#item_flags]
	MOV	r1,#-1
	STR	r1,[r2,#item_submenu]
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

maddw_flags
	DCD	&07000101

	AREA	|____menu_split|, CODE, READONLY
	EXPORT	menu_split
menu_split

	ADD	r0,r0,r1,LSL#3
	ADD	r0,r0,r1,LSL#4
	LDR	r1,[r0,#item_data+item_flags]
	TEQ	r2,#0
	BICEQ	r1,r1,#2
	ORRNE	r1,r1,#2
	STR	r1,[r0,#item_data+item_flags]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_displayiconbar|, CODE, READONLY
	EXPORT	menu_displayiconbar
menu_displayiconbar

	STMFD	r13!,{r4,lr}
	MOV	r2,r0
	LDR	r1,=menu_mouse
	SWI	XWimp_GetPointerInfo
	LDR	r3,=menu_created
	MOV	r0,r1
	ADD	r1,r2,#menu_title
	STR	r1,[r3]
	LDMIA	r0,{r2,r3}
	SUB	r2,r2,#64
	MOV	r3,#96
	ADD	r0,r1,#28
mdib_loop
	LDR	r4,[r0],#24
	ADD	r3,r3,#44
	TST	r4,#2
	ADDNE	r3,r3,#24
	TST	r4,#128
	BEQ	mdib_loop
	LDR	r0,=menu_xy
	STMIA	r0,{r2,r3}
	SWI	XWimp_CreateMenu
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____menu_clear|, CODE, READONLY
	EXPORT	menu_clear
menu_clear

	MOV	r1,#0
	STR	r1,[r0,#items_defined]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_changetext|, CODE, READONLY
	EXPORT	menu_changetext
menu_changetext

	ADD	r0,r0,r1,LSL#3
	ADD	r0,r0,r1,LSL#4
	MOV	r1,r2
mcgt_count
	LDRB	r3,[r1],#1
	CMP	r3,#32
	BGE	mcgt_count
	SUB	r1,r1,r2					; r1 is the size
	CMP	r1,#12
	BLT	mcgt_small
	STR	r1,[r0,#item_iconlength+item_data]
	LDR	r1,[r0,#item_iconflags+item_data]
	TST	r1,#256
	ORR	r1,r1,#256
	STREQ	r1,[r0,#item_iconflags+item_data]
	MOVEQ	r1,#-1
	STREQ	r1,[r0,#item_iconvalid+item_data]
	STR	r2,[r0,#item_icontext+item_data]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]
mcgt_small
	LDR	r1,[r0,#item_iconflags+item_data]
	BIC	r1,r1,#256
	STR	r1,[r0,#item_iconflags+item_data]
	MOV	r1,r2
	ADD	r1,r0,#item_icontext+item_data
mcgt_copy
	LDRB	r3,[r2],#1
	STRB	r3,[r1],#1
	CMP	r3,#32
	BGE	mcgt_copy
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_displaycanvas|, CODE, READONLY
	EXPORT	menu_displaycanvas
menu_displaycanvas

	MOV	r1,#0
	LDR	r2,=submenu_created
	STR	r1,[r2]
	LDR	r2,=menu_created
	STR	r1,[r2]
	ADD	r1,r0,#canvas_window
	LDR	r2,[r0,#window_handle]
	SWI	XWimp_GetPointerInfo
	LDMIA	r1,{r1,r3}
	EOR	r1,r1,r2
	EOR	r2,r1,r2
	EOR	r1,r1,r2
	SUB	r2,r2,#64
	LDR	r0,=menu_xy
	STMIA	r0,{r2,r3}
	SWI	XWimp_CreateMenu
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_subwarning|, CODE, READONLY
	EXPORT	menu_subwarning
menu_subwarning

	ADD	r0,r0,r1,LSL#4
	ADD	r0,r0,r1,LSL#3
	LDR	r1,[r0,#item_data]
	ORR	r1,r1,#8
	STR	r1,[r0,#item_data]
	IMPORT	canvas_iconbar
	LDR	r1,=canvas_iconbar
	STR	r1,[r0,#item_data+item_submenu]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_displaysubcanvas|, CODE, READONLY
	EXPORT	menu_displaysubcanvas
menu_displaysubcanvas

	IMPORT	poll_block
	IMPORT	poll_lastevent

	LDR	r1,[r0,#window_handle]
	LDR	r3,=poll_block
	LDR	r2,=poll_lastevent
	LDR	r2,[r2]
	TEQ	r2,#17
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	LDR	r2,[r3,#16]
	EOR	r2,r2,#&40000
	TEQ	r2,#&c0
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	LDR	r2,[r3,#24]
	LDR	r3,[r3,#28]
;	LDR	r0,=submenu_created
;	STMIA	r0,{r1,r2,r3}
	SWI	XWimp_CreateSubMenu
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	LTORG

	AREA	|____menu_displaysubmenu|, CODE, READONLY
	EXPORT	menu_displaysubmenu
menu_displaysubmenu

	ADD	r1,r0,#menu_title
	LDR	r3,=poll_block
	LDR	r2,=poll_lastevent
	LDR	r2,[r2]
	TEQ	r2,#17
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	LDR	r2,[r3,#16]
	EOR	r2,r2,#&40000
	TEQ	r2,#&c0
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	LDR	r2,[r3,#24]
	LDR	r3,[r3,#28]
	LDR	r0,=submenu_created
	STMIA	r0,{r1,r2,r3}
	SWI	XWimp_CreateSubMenu
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	MACRO
$l	WINOFFSETS	$w,$x,$y,$o
$l	ROUT
	LDR	r0,[r1,#$w]
	CMP	r0,#-2
	BEQ	%f00
	ADD	r1,r1,#$o
	STR	r0,[r1]
	SWI	XWimp_GetWindowState
	LDR	r0,[r1]
	SUB	r1,r1,#$o
	LDR	r2,[r1,#$o+20]
	LDR	r3,[r1,#$o+4]
	SUB	r3,r3,r2
	LDR	r2,[r1,#$x]
	ADD	r2,r2,r3
	STR	r2,[r1,#$x]
	LDR	r2,[r1,#$o+24]
	LDR	r3,[r1,#$o+16]
	SUB	r3,r3,r2
	LDR	r2,[r1,#$y]
	ADD	r2,r2,r3
	STR	r2,[r1,#$y]
00
	MEND

	AREA	|____menu_displayicon|, CODE
	EXPORT	menu_displayicon
menu_displayicon

; r0 is ^ menu
; r1 is ^ icon

	STMFD	r13!,{r4,lr}
	MOV	r4,r0
	LDR	r2,[r1,#28]				; Get canvas's...
	LDR	r2,[r2,#8]				; ...window handle
	LDR	r3,[r1,#4]				; Icon's handle
	ADR	r1,mdi__t
	STMIA	r1,{r2,r3}
	SWI	XWimp_GetIconState
	WINOFFSETS	0,16,20,24
	LDR	r2,[r1,#16]
	ADD	r2,r2,#2
	LDR	r3,[r1,#20]
	LDR	r0,=menu_created
	ADD	r1,r4,#menu_title
	STR	r1,[r0]
	LDR	r0,=menu_xy
	STMIA	r0,{r2,r3}
	SWI	XWimp_CreateMenu
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

mdi__t	%	80

	LTORG

	AREA	|____menu_displaycanvasicon|, CODE
	EXPORT	menu_displaycanvasicon
menu_displaycanvasicon

; r0 is ^ canvas
; r1 is ^ icon

	STMFD	r13!,{r4,lr}
	MOV	r4,r0
	LDR	r2,[r1,#28]				; Get canvas's...
	LDR	r2,[r2,#8]				; ...window handle
	LDR	r3,[r1,#4]				; Icon's handle
	ADR	r1,mdci__t
	STMIA	r1,{r2,r3}
	SWI	XWimp_GetIconState
	WINOFFSETS	0,16,20,24
	LDR	r2,[r1,#16]
	ADD	r2,r2,#2
	LDR	r3,[r1,#20]
	LDR	r0,=menu_created
	MOV	r1,#0
	STR	r1,[r4]
	LDR	r1,[r4,#window_handle]
	LDR	r0,=menu_xy
	STMIA	r0,{r2,r3}
	SWI	XWimp_CreateMenu
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

mdci__t	%	80

	LTORG

	AREA	|____menu_remove|, CODE, READONLY
	EXPORT	menu_remove
menu_remove

	MOV	r1,#-1
	SWI	XWimp_CreateMenu
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_settitle|, CODE, READONLY
	EXPORT	menu_settitle
menu_settitle

	ADD	r0,r0,#menu_title
	MOV	r3,#11
mst_ll	LDRB	r2,[r1,r3]
	STRB	r2,[r0,r3]
	SUBS	r3,r3,#1
	BPL	mst_ll
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____menu_checkwidth|, CODE, READONLY
	EXPORT	menu_checkwidth
menu_checkwidth

	ADD	r1,r0,#item_data
	MOV	r2,#0
	LDR	r3,[r0,#items]
	TEQ	r3,#0
 [ arm32
	MOVEQ	pc,lr
 |
	MOVEQS	pc,lr
 ]
	STMFD	r13!,{r4-r6,lr}
mcwl	LDRB	r4,[r1,#item_iconflags+1]
	TST	r4,#1
	LDRNE	r4,[r1,#item_icontext]
	ADDEQ	r4,r1,#item_icontext
	MOV	r5,#32
mcwl1	LDRB	r6,[r4],#1
	CMP	r6,#32
	ADDCS	r5,r5,#16
	BCS	mcwl1
	CMP	r5,r2
	MOVGT	r2,r5
	SUBS	r3,r3,#1
	BGT	mcwl
	STR	r2,[r0,#width]
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	END
